# Defiant <mail@defiant.homedns.org>
#
# Self Destruct Countdown
# changed Code from a Totally Games scripter (see README)
# Kirk Version

import App
import MissionLib
import Bridge.BridgeUtils
import Lib.Ambiguity
import QuickBattle.QuickBattle

pMission = MissionLib.GetMission()
g_pMissionDatabase = pMission.SetDatabase("data/TGL/SelfDestruct-Kirk.tgl")
pBridge = App.g_kSetManager.GetSet('bridge')
g_pSaffi = App.CharacterClass_GetObject(pBridge, 'XO')
pSaffiMenu = Bridge.BridgeUtils.GetBridgeMenu('XO')
g_iCountdown = -1
MySelfDestructCaller = None
SDpPlayer = None

App.TopWindow_GetTopWindow().AddPythonFuncHandlerForInstance(App.ET_INPUT_SELF_DESTRUCT, __name__ + ".MySelfDestructStart")

if (pSaffiMenu != None):
	event = Lib.Ambiguity.getEvent("ET_INPUT_SELF_DESTRUCT")
	g_pSaffi.AddPythonFuncHandlerForInstance(event, __name__ + ".MySelfDestructStart")
	pButton = QuickBattle.QuickBattle.CreateBridgeMenuButton(App.TGString('Self Destruct'), event, 0, g_pSaffi)
	pSaffiMenu.PrependChild(pButton)


def MySelfDestructStart(pObject, pEvent):
	global g_iCountdown
	global MySelfDestructCaller
	global SDpPlayer

	if (g_iCountdown == -1):
		# mySelfDestruct: Start
		
		# This makes sure we kill the right ship (when transporting on another)
		SDpPlayer = MissionLib.GetPlayer()
		if not (SDpPlayer):
			return
			
		MySelfDestruct()
	# Now test what Function is calling us
	elif (str(MySelfDestructCaller) == str(pEvent)):
		if (g_iCountdown != -2):
			# mySelfDestruct: Go on
			MySelfDestruct()
	else:
		if (g_iCountdown == -2):
			# resetting g_iCountdown
			g_iCountdown = -1
		else:
			# mySelfDestruct: Cancel
			CancelSelfDestruct()


def MySelfDestruct():
	global g_iCountdown
	global MySelfDestructCaller
	
	MySelfDestructCaller = None
	
	if (g_iCountdown == -1):
		# We are starting our countdown..
		g_iCountdown = 45
		# its 14 cause we need more time for auth...
	elif (g_iCountdown == 0):
        	# We're dead!
	        FinallyDie()
        	return

	# Create an event - it's a thing that will call this function
	pTimerEvent = App.TGEvent_Create()
	pTimerEvent.SetEventType(App.ET_INPUT_SELF_DESTRUCT)
	pTimerEvent.SetDestination(App.TopWindow_GetTopWindow())

	SDCounterTime = 1.0
	
	# Create a timer - it's a thing that will wait for a given time,then do something
	pTimer = App.TGTimer_Create()
	pTimer.SetTimerStart(App.g_kUtopiaModule.GetGameTime() + SDCounterTime)
	pTimer.SetDelay(0)
	pTimer.SetDuration(0)
	pTimer.SetEvent(pTimerEvent)
	App.g_kTimerManager.AddTimer(pTimer)
	MySelfDestructCaller = pTimerEvent
	
	# And finally, call out the line..
	pCharacter = App.CharacterClass_Cast(App.g_kSetManager.GetSet("bridge").GetObject("XO"))
	if (pCharacter):
		pSequence = App.TGSequence_Create()
		# Needed some Custom Values cause Saffi is speaking too slow!
		if ( g_iCountdown == 45):
			pSequence.AppendAction(App.CharacterAction_Create(pCharacter, App.CharacterAction.AT_SAY_LINE, "InitSelfDestruct1", "Captain", 1, g_pMissionDatabase))
		elif ( g_iCountdown == 37):
			pSequence.AppendAction(App.CharacterAction_Create(pCharacter, App.CharacterAction.AT_SAY_LINE, "InitSelfDestruct2", "Captain", 1, g_pMissionDatabase))
		elif ( g_iCountdown == 29):
			pSequence.AppendAction(App.CharacterAction_Create(pCharacter, App.CharacterAction.AT_SAY_LINE, "InitSelfDestruct3", "Captain", 1, g_pMissionDatabase))
		elif ( g_iCountdown == 18):
			pSequence.AppendAction(App.CharacterAction_Create(pCharacter, App.CharacterAction.AT_SAY_LINE, "InitSelfDestructFinal", "Captain", 1, g_pMissionDatabase))
		elif ( g_iCountdown <= 10):
			pSequence.AppendAction(App.CharacterAction_Create(pCharacter, App.CharacterAction.AT_SAY_LINE, "SelfDestruct" + str(g_iCountdown), "Captain", 1, g_pMissionDatabase))

		pSequence.Play()		

	g_iCountdown = g_iCountdown - 1
	

def FinallyDie():
	global g_iCountdown
	global SDpPlayer
	
	g_iCountdown = -1
	MySelfDestructCaller = None
	
	#print("Now we kill us")
	SDpPlayer.DestroySystem(SDpPlayer.GetHull())


def CancelSelfDestruct():
	global g_iCountdown
	global SDpPlayer
	
	# set it to -2: lock it so all calls from MySelfDestruct() will land in /dev/null
	g_iCountdown = -2
	SDpPlayer = None
	
	pCharacter = App.CharacterClass_Cast(App.g_kSetManager.GetSet("bridge").GetObject("XO"))
	if (pCharacter):
		pSequence = App.TGSequence_Create()
		pSequence.AppendAction(App.CharacterAction_Create(pCharacter, App.CharacterAction.AT_SAY_LINE, "SelfDestructCancel", "Captain", 1, g_pMissionDatabase))
		pSequence.Play()		

def Restart():
	global g_iCountdown
	global SDpPlayer
	
	if ( g_iCountdown > -1 ):
		CancelSelfDestruct()
		SDpPlayer = None